diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/RubyglassFloeLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/RubyglassFloeLargeFeature.java
new file mode 100644
index 000000000..39cb00389
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/RubyglassFloeLargeFeature.java
@@ -0,0 +1,85 @@
+package net.minecraft.core.world.generate;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
+import net.minecraft.core.world.noise.Noise2D;
+import net.minecraft.core.world.noise.WorleyNoise;
+import net.minecraft.core.world.noise.operator.Normalize2D;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class RubyglassFloeLargeFeature extends LargeFeature {
+	private @Nullable WorleyNoise chunkNoise = null;
+	private @Nullable Noise2D gapNoise = null;
+	private @Nullable Noise2D scaleNoise = null;
+	private @Nullable World lastWorld = null;
+
+	public RubyglassFloeLargeFeature() {
+	}
+
+	protected void doGeneration(@NotNull World world, @NotNull Random random, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result) {
+		if (this.chunkNoise == null || this.gapNoise == null || this.scaleNoise == null || this.lastWorld != world) {
+			this.chunkNoise = new WorleyNoise(new Random(world.getRandomSeed()));
+			this.gapNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4));
+			this.scaleNoise = new Normalize2D<>(new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 2)));
+			this.lastWorld = world;
+		}
+
+		WorldType worldType = world.getWorldType();
+		int oceanY = worldType.getMinY(world) + worldType.getOceanY();
+		TilePos tilePos = new TilePos();
+		WorleyNoise.Result worleyResult = new WorleyNoise.Result();
+
+		for (int x = 0; x < 16; ++x) {
+			for (int z = 0; z < 16; ++z) {
+				tilePos.set(16 * baseChunkX + x, oceanY, 16 * baseChunkZ + z);
+				Biome biome = world.getBlockBiome(tilePos);
+				if (biome == Biomes.NETHER_CRYSTAL_FOREST || biome == Biomes.NETHER_CRYSTAL_PLAINS) {
+
+					double sampleX = (double) baseChunkX + (double) x / 16.0;
+					double sampleZ = (double) baseChunkZ + (double) z / 16.0;
+					this.chunkNoise.getValue(sampleX, sampleZ, worleyResult);
+
+					double lineScale = 15.0;
+					double lineWidth = this.gapNoise.getValue((double) (baseChunkX * 16 + x) / lineScale, (double) (baseChunkZ * 16 + z) / lineScale) / 2.0 + 0.5;
+					double edgeThreshold = 0.8 + lineWidth * 0.05;
+
+					if (MathHelper.unsignedMod(worleyResult.index, 15.0F) != 0.0 && worleyResult.distance <= edgeThreshold) {
+
+						double thicknessVariation = this.scaleNoise.getValue((double) x / 10.0, (double) z / 10.0);
+						int depth = (int) (thicknessVariation * 6.0);
+						for (int y = oceanY - (depth + 2); y < oceanY; ++y) {
+							this.trySetBlock(result, x, y, z, Blocks.COBBLE_NETHERRACK_CRYSTALLINE.id());
+						}
+
+						for (int y = oceanY; y < oceanY + depth; ++y) {
+							this.trySetBlock(result, x, y, z, Blocks.COBBLE_NETHERRACK.id());
+						}
+					}
+				}
+			}
+		}
+	}
+
+	private void trySetBlock(@NotNull ChunkGeneratorResult result, int x, int y, int z, int id) {
+		int current = result.getBlock(x, y, z);
+		if (current == Blocks.RUBYGLASS_CRYSTAL.id() || current == Blocks.FLUID_WATER_STILL.id() || current == Blocks.AIR.id()) {
+			result.setBlock(x, y, z, id);
+		}
+	}
+
+	@Override
+	public int getRadiusChunk() {
+		return 0;
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkDecorationBuilder.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkDecorationBuilder.java
index ad4d89526..7259cfe1b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkDecorationBuilder.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkDecorationBuilder.java
@@ -6,8 +6,8 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.feature.WorldFeatureInterface;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
-import java.util.Arrays;
 import java.util.Random;
 
 public class ChunkDecorationBuilder implements ChunkDecoration
@@ -16,6 +16,13 @@ public class ChunkDecorationBuilder implements ChunkDecoration
     private @NotNull PlacementMethod placementMethod = PlacementMethods.OncePerChunk;
     private @NotNull Biome[] biomeMask = new Biome[]{};
     private @NotNull PositionSelector positionSelector = PositionSelectors.SurfaceBlock;
+
+    private final TilePos scratchPos = new TilePos();
+    private @Nullable PlaceableFeature cachedPlaceable;
+    private int cachedMinY;
+    private int cachedMaxY;
+    private int cachedRangeY;
+
     public ChunkDecorationBuilder(final @NotNull WorldFeatureInterface worldFeature){
         this.worldFeature = worldFeature;
     }
@@ -38,13 +45,34 @@ public class ChunkDecorationBuilder implements ChunkDecoration
 
     @Override
     public void placeDecoration(@NotNull World world, @NotNull Chunk chunk, int worldX, int worldZ, int minY, int maxY, int rangeY, @NotNull Random rand) {
+        if (this.biomeMask.length != 0) {
+            int checkY = minY + (maxY - minY) / 2;
+            checkY = Math.max(world.getWorldType().getMinY(world), Math.min(world.getWorldType().getMaxY(world) - 1, checkY));
 
-        if(biomeMask.length > 0){
-            if(!Arrays.asList(biomeMask).contains(world.getBlockBiome(new TilePos(worldX, minY, worldZ)))){
+            this.scratchPos.set(worldX, checkY, worldZ);
+            final Biome here = world.getBlockBiome(this.scratchPos);
+            if (!this.biomeMaskContains(here)) {
                 return;
             }
         }
 
-        placementMethod.placeFeature(new PlaceableFeature(this.worldFeature, this.positionSelector, minY, maxY, rangeY), world, chunk, rand);
+        if (this.cachedPlaceable == null || minY != this.cachedMinY || maxY != this.cachedMaxY || rangeY != this.cachedRangeY) {
+            this.cachedPlaceable = new PlaceableFeature(this.worldFeature, this.positionSelector, minY, maxY, rangeY);
+            this.cachedMinY = minY;
+            this.cachedMaxY = maxY;
+            this.cachedRangeY = rangeY;
+        }
+
+        this.placementMethod.placeFeature(this.cachedPlaceable, world, chunk, rand);
+    }
+
+    private boolean biomeMaskContains(@NotNull Biome biome) {
+        final Biome[] mask = this.biomeMask;
+        for (int i = 0, n = mask.length; i < n; i++) {
+            if (mask[i] == biome) {
+                return true;
+            }
+        }
+        return false;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java
index ba47c0510..ba54249c7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkFeatureDecorator.java
@@ -1,21 +1,36 @@
 package net.minecraft.core.world.generate.chunk;
 
+import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2IntLinkedOpenHashMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
-import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.block.BlockLogicFallingBlock;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 import java.util.Random;
 
 public abstract class ChunkFeatureDecorator
-    implements ChunkDecorator {
+        implements ChunkDecorator {
+    private static final @NotNull Logger LOGGER = LogUtils.getLogger();
+
     private boolean initialized = false;
     private final @NotNull World world;
-    private final @NotNull Object2IntMap<ChunkDecoration> decorations = new Object2IntOpenHashMap<>();
+
+    private final @NotNull Object2IntMap<ChunkDecoration> decorations = new Object2IntLinkedOpenHashMap<>();
+
+    private ChunkDecoration @Nullable [] decorationArray;
+    private int @Nullable [] decorationSeedArray;
+
+    private boolean seedConstantsInitialized = false;
+    private long seedMultiplierA;
+    private long seedMultiplierB;
+
+    private final @NotNull Random sharedRand = new Random();
 
     public ChunkFeatureDecorator(final @NotNull World world) {
         this.world = world;
@@ -41,39 +56,82 @@ public abstract class ChunkFeatureDecorator
 
     public final @NotNull ChunkFeatureDecorator register(final @NotNull NamespaceID id, final @NotNull ChunkDecoration decoration) {
         this.decorations.put(decoration, id.toString().hashCode());
-
+        this.decorationArray = null;
+        this.decorationSeedArray = null;
         return this;
     }
 
+    private void bakeDecorations() {
+        final int n = this.decorations.size();
+        final ChunkDecoration[] decoArr = new ChunkDecoration[n];
+        final int[] seedArr = new int[n];
+
+        int i = 0;
+        for (final Object2IntMap.Entry<ChunkDecoration> entry : this.decorations.object2IntEntrySet()) {
+            decoArr[i] = entry.getKey();
+            seedArr[i] = entry.getIntValue();
+            i++;
+        }
+
+        this.decorationArray = decoArr;
+        this.decorationSeedArray = seedArr;
+    }
+
     @Override
     public final void decorate(final @NotNull Chunk chunk) {
         this.world.scheduledUpdatesAreImmediate = true;
         BlockLogicFallingBlock.fallInstantly = true;
 
-        final int chunkX = chunk.pos.x;
-        final int chunkZ = chunk.pos.z;
-        final int worldX = chunkX * 16;
-        final int worldZ = chunkZ * 16;
-
-        final int minY = this.world.getWorldType().getMinY(world);
-        final int maxY = this.world.getWorldType().getMaxY(world);
-        final int rangeY = (maxY + 1) - minY;
-
-        final @NotNull Random rand = new Random(this.world.getRandomSeed());
-        final long a = (rand.nextLong() / 2L) * 2L + 1L;
-        final long b = (rand.nextLong() / 2L) * 2L + 1L;
-
-        for (final @NotNull ChunkDecoration decoration : this.decorations.keySet()) {
-            final int decorationSeed = this.decorations.getInt(decoration);
-            rand.setSeed((long) chunkX * a + (long) chunkZ * b ^ this.world.getRandomSeed() ^ decorationSeed);
-            decoration.placeDecoration(this.world, chunk, worldX, worldZ, minY, maxY, rangeY, rand);
+        try {
+            final int chunkX = chunk.pos.x;
+            final int chunkZ = chunk.pos.z;
+            final int worldX = chunkX * 16;
+            final int worldZ = chunkZ * 16;
+
+            final int minY = this.world.getWorldType().getMinY(world);
+            final int maxY = this.world.getWorldType().getMaxY(world);
+            final int rangeY = (maxY + 1) - minY;
+
+            final long worldSeed = this.world.getRandomSeed();
+            if (!this.seedConstantsInitialized) {
+                final Random seedRand = new Random(worldSeed);
+                this.seedMultiplierA = (seedRand.nextLong() / 2L) * 2L + 1L;
+                this.seedMultiplierB = (seedRand.nextLong() / 2L) * 2L + 1L;
+                this.seedConstantsInitialized = true;
+            }
+
+            if (this.decorationArray == null || this.decorationSeedArray == null) {
+                this.bakeDecorations();
+            }
+
+            final ChunkDecoration[] decoArr = this.decorationArray;
+            final int[] seedArr = this.decorationSeedArray;
+            final long a = this.seedMultiplierA;
+            final long b = this.seedMultiplierB;
+            final Random rand = this.sharedRand;
+
+            for (int i = 0, n = decoArr.length; i < n; i++) {
+                assert seedArr != null;
+                rand.setSeed((long) chunkX * a + (long) chunkZ * b ^ worldSeed ^ seedArr[i]);
+                try {
+                    decoArr[i].placeDecoration(this.world, chunk, worldX, worldZ, minY, maxY, rangeY, rand);
+                } catch (final Throwable t) {
+                    LOGGER.error("Decoration {} failed at chunk ({}, {}); continuing with remaining decorations.",
+                            i, chunkX, chunkZ, t);
+                }
+            }
+
+            try {
+                this.postDecorate(this.world, chunk);
+            } catch (final Throwable t) {
+                LOGGER.error("postDecorate failed at chunk ({}, {}).", chunkX, chunkZ, t);
+            }
+
+        } finally {
+            BlockLogicFallingBlock.fallInstantly = false;
+            this.world.scheduledUpdatesAreImmediate = false;
         }
-
-        this.postDecorate(this.world, chunk);
-
-        BlockLogicFallingBlock.fallInstantly = false;
-        this.world.scheduledUpdatesAreImmediate = false;
     }
 
     public abstract void postDecorate(final @NotNull World world, final @NotNull Chunk chunk);
-}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index 7a9f1af6c..bc07f6874 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -1,7 +1,8 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicOreNetherCoal;
-import net.minecraft.core.block.BlockLogicOreRubyglass;
+import net.minecraft.core.block.BlockLogicNodeRubyglass;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
@@ -10,7 +11,6 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.*;
 import net.minecraft.core.world.generate.feature.*;
-import net.minecraft.core.world.generate.feature.tree.WorldFeatureBoneshaleTree;
 import net.minecraft.core.world.noise.FractalNoise2D;
 import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import net.minecraft.core.world.noise.WorleyNoise;
